Index: java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 101)
@@ -1,4 +1,3 @@
 package com.framsticks.core;
-
 
 import java.util.HashSet;
@@ -22,5 +21,5 @@
 import com.framsticks.params.PropertiesAccess;
 import com.framsticks.params.UniqueListAccess;
-import com.framsticks.params.Util;
+import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ObjectParam;
@@ -43,7 +42,8 @@
 	}
 
-	public static final Object FETCHED_MARK = new Object();
-
-	public static @Nonnull FramsClass processFetchedInfo(Tree tree, File file) {
+	public static final SideNoteKey<Boolean> FETCHED_MARK = SideNoteKey.make(Boolean.class);
+
+	public static @Nonnull
+	FramsClass processFetchedInfo(Tree tree, File file) {
 		assert tree.isActive();
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
@@ -80,5 +80,4 @@
 		assert path.isTheSame(files.get(0).getPath());
 
-
 		try {
 			log.debug("process fetched values: {}", path);
@@ -98,10 +97,9 @@
 					if (path.getTop().getParam() instanceof ObjectParam) {
 						assert results.size() == 1;
-						Util.takeAllNonNullValues(bindAccess(result), parsingAccess.select(results.get(0)));
+						ParamsUtil.takeAllNonNullValues(bindAccess(result), parsingAccess.select(results.get(0)));
 						mark(result.getTree(), result.getTopObject(), FETCHED_MARK, true);
 						future.pass(result);
 						return;
 					}
-
 
 					final ListAccess listAccess = (ListAccess) access;
@@ -139,5 +137,5 @@
 
 						targetAccess.select(childTo);
-						Util.takeAllNonNullValues(targetAccess, parsingAccess);
+						ParamsUtil.takeAllNonNullValues(targetAccess, parsingAccess);
 						if (newOne) {
 							listAccess.set(id, childTo);
@@ -188,7 +186,7 @@
 	}
 
-
-	public static @Nonnull Access bindAccessFromSideNote(Tree tree, Object object) {
-		CompositeParam param = tree.getSideNote(object, CompositeParam.class, CompositeParam.class);
+	public static @Nonnull
+	Access bindAccessFromSideNote(Tree tree, Object object) {
+		CompositeParam param = tree.getSideNote(object, Path.OBJECT_PARAM_KEY);
 		if (param == null) {
 			throw new FramsticksException().msg("failed to bind access from side node").arg("tree", tree).arg("object", object).arg("type", object.getClass());
@@ -197,10 +195,12 @@
 	}
 
-	public static @Nonnull Access bindAccess(Tree tree, String path) {
+	public static @Nonnull
+	Access bindAccess(Tree tree, String path) {
 		log.debug("bind access for textual: {} in {}", path, tree);
 		return bindAccess(Path.to(tree, path));
 	}
 
-	public static @Nonnull Access bindAccess(Node node) {
+	public static @Nonnull
+	Access bindAccess(Node node) {
 		Tree tree = node.getTree();
 		assert tree.isActive();
@@ -209,5 +209,5 @@
 		try {
 			Access access = tree.prepareAccess(node.getParam());
-			tree.putSideNote(node.getObject(), CompositeParam.class, node.getParam());
+			tree.putSideNote(node.getObject(), Path.OBJECT_PARAM_KEY, node.getParam());
 
 			return access.select(node.getObject());
@@ -218,5 +218,6 @@
 	}
 
-	public static @Nonnull Access bindAccess(Path path) {
+	public static @Nonnull
+	Access bindAccess(Path path) {
 		assert path.getTree().isActive();
 		path.assureResolved();
@@ -280,5 +281,4 @@
 		});
 	}
-
 
 	/**
@@ -323,5 +323,5 @@
 	public static Object createAccessee(Tree tree, CompositeParam param) {
 		Object object = tree.prepareAccess(param).createAccessee();
-		tree.putSideNote(object, CompositeParam.class, param);
+		tree.putSideNote(object, Path.OBJECT_PARAM_KEY, param);
 		return object;
 	}
@@ -329,15 +329,15 @@
 	public static Object createAccessee(Tree tree, Access access) {
 		Object object = access.createAccessee();
-		tree.putSideNote(object, CompositeParam.class, access.buildParam(new ParamBuilder()).finish(CompositeParam.class));
+		tree.putSideNote(object, Path.OBJECT_PARAM_KEY, access.buildParam(new ParamBuilder()).finish(CompositeParam.class));
 		return object;
 	}
 
-	public static boolean isMarked(Tree tree, Object object, Object mark, boolean defValue) {
-		assert tree.isActive();
-		Boolean v = tree.getSideNote(object, mark, Boolean.class);
+	public static boolean isMarked(Tree tree, Object object, SideNoteKey<Boolean> mark, boolean defValue) {
+		assert tree.isActive();
+		Boolean v = tree.getSideNote(object, mark);
 		return (v != null ? v : defValue);
 	}
 
-	public static void mark(Tree tree, Object object, Object mark, boolean value) {
+	public static void mark(Tree tree, Object object, SideNoteKey<Boolean> mark, boolean value) {
 		assert tree.isActive();
 		tree.putSideNote(object, mark, value);
@@ -348,3 +348,38 @@
 	}
 
+	public static <T extends Param> T getParam(Path path, String id, Class<T> type) {
+		return getFramsClass(path).getParamEntry(id, type);
+	}
+
+	public static <T> T getOrCreateSideNote(Tree tree, Object object, SideNoteKey<T> key) {
+		T result = tree.getSideNote(object, key);
+		if (result == null) {
+			result = key.newValue();
+			tree.putSideNote(object, key, result);
+		}
+		return result;
+	}
+
+	public static <T> boolean hasSideNotes(Tree tree, Object object, SideNoteKey<T> key) {
+		return tree.getSideNote(object, key) != null;
+	}
+
+	public static <T> boolean hasSideNote(Path path, SideNoteKey<T> key) {
+		return path.getTree().getSideNote(path.getTopObject(), key) != null;
+	}
+
+	public static <T> T getSideNote(Path path, SideNoteKey<T> key) {
+		assert path.isResolved();
+		return path.getTree().getSideNote(path.getTopObject(), key);
+	}
+
+	public static <T> void putSideNote(Path path, SideNoteKey<T> key, T value) {
+		path.getTree().putSideNote(path.getTopObject(), key, value);
+	}
+
+	public static boolean removeSideNote(Path path, SideNoteKey<?> key) {
+		assert path.isResolved();
+		return path.getTree().removeSideNote(path.getTopObject(), key);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/core/ValueChange.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ValueChange.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/core/ValueChange.java	(revision 101)
@@ -0,0 +1,32 @@
+package com.framsticks.core;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.lang.Strings;
+
+@FramsClassAnnotation
+public class ValueChange {
+
+	@ParamAnnotation
+	public Object value;
+
+
+	/**
+	 * @param value
+	 */
+	public ValueChange(Object value) {
+		this.value = value;
+	}
+
+	/**
+	 *
+	 */
+	public ValueChange() {
+	}
+
+	@Override
+	public String toString() {
+		return Strings.toStringNullProof(value, "<null>");
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/experiment/Experiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 101)
@@ -0,0 +1,37 @@
+package com.framsticks.experiment;
+
+import java.util.Map;
+
+import com.framsticks.core.ListChange;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.SimpleUniqueList;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.dispatching.JoinableCollection;
+
+@FramsClassAnnotation
+public class Experiment extends JoinableCollection<Simulator> {
+
+	protected final SimpleUniqueList<Simulator> simulators = new SimpleUniqueList<>(Simulator.class, 's');
+
+	@ParamAnnotation
+	public Map<String, Simulator> getSimulators() {
+		return simulators.getView();
+	}
+
+	@ParamAnnotation(id = "simulators_changed")
+	public void addSimulatorsListener(EventListener<ListChange> listener) {
+		simulators.addListener(listener);
+	}
+
+	@ParamAnnotation(id = "simulators_changed")
+	public void removeSimulatorsListener(EventListener<ListChange> listener) {
+		simulators.removeListener(listener);
+	}
+
+	@AutoAppendAnnotation
+	public void addSimulator(Simulator simulator) {
+		simulators.add(simulator);
+	}
+}
Index: java/main/src/main/java/com/framsticks/experiment/Simulator.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 101)
@@ -0,0 +1,103 @@
+package com.framsticks.experiment;
+
+import com.framsticks.params.ParamFlags;
+import com.framsticks.params.UniqueObject;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.remote.RemoteTree;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+
+@FramsClassAnnotation
+public class Simulator extends AbstractJoinable implements JoinableParent, UniqueObject {
+	protected String uid;
+
+	protected final RemoteTree remoteTree = new RemoteTree();
+
+	/**
+	 *
+	 */
+	public Simulator() {
+		super();
+	}
+
+	@ParamAnnotation
+	public void setAddress(String address) {
+		remoteTree.setAddress(address);
+	}
+
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public String getAddress() {
+		return remoteTree.getAddress();
+	}
+
+	@Override
+	@ParamAnnotation
+	public String getName() {
+
+		return "simulator " + uid + " " + getAddress();
+	}
+
+	@Override
+	@ParamAnnotation
+	public String getUid() {
+		return uid;
+	}
+
+	@Override
+	public void setUid(String uid) {
+		this.uid = uid;
+	}
+
+	/**
+	 * @return the tree
+	 */
+	@ParamAnnotation
+	public RemoteTree getRemoteTree() {
+		return remoteTree;
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(remoteTree, this);
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(remoteTree, this);
+
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(remoteTree);
+	}
+
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void init() {
+	}
+
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void start() {
+	}
+
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void stop() {
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 101)
@@ -1,4 +1,7 @@
 package com.framsticks.gui;
 
+import com.framsticks.communication.File;
+import com.framsticks.communication.queries.NeedFile;
+import com.framsticks.communication.queries.NeedFileAcceptor;
 import com.framsticks.core.*;
 import com.framsticks.gui.console.Console;
@@ -9,4 +12,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.parsers.FileSource;
 import com.framsticks.remote.RemoteTree;
 import com.framsticks.util.FramsticksException;
@@ -22,4 +26,5 @@
 
 import javax.swing.*;
+import javax.swing.filechooser.FileNameExtensionFilter;
 
 import org.apache.logging.log4j.Logger;
@@ -30,8 +35,16 @@
 import java.awt.datatransfer.StringSelection;
 import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.awt.event.WindowAdapter;
+import java.awt.event.WindowEvent;
+import java.io.IOException;
 import java.util.ArrayList;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
 import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.lang.Strings;
 
 /**
@@ -132,10 +145,83 @@
 	}
 
+	protected static final Pattern extensionFilterPattern = Pattern.compile("\\*\\.(\\S+)");
+
 	@AutoAppendAnnotation
-	public void addTree(Tree tree) {
+	public void addTree(final Tree tree) {
 		log.debug("adding tree: {}", tree);
 		tree.setDispatcher(new SwingDispatcher<Tree>());
 		tree.setExceptionHandler(this);
 		trees.add(tree);
+
+		final NeedFileAcceptor acceptor = new NeedFileAcceptor() {
+
+			protected boolean done = false;
+
+			@Override
+			public boolean acceptNeed(final NeedFile needFile) {
+				final JFileChooser chooser = new JFileChooser();
+				final JFrame frame = new JFrame();
+
+				frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
+
+				frame.addWindowListener(new WindowAdapter() {
+					@Override
+					public void windowClosing(WindowEvent e) {
+						if (!done) {
+							needFile.getFuture().handle(new FramsticksException().msg("user closed the window"));
+						}
+						frame.setVisible(false);
+						frame.dispose();
+					}
+				});
+
+				frame.setTitle(Strings.toStringEmptyProof(needFile.getDescription(), "Choose file"));
+				chooser.setMultiSelectionEnabled(false);
+				Matcher matcher = extensionFilterPattern.matcher(needFile.getSuggestedName());
+				if (matcher.matches()) {
+					chooser.setFileFilter(new FileNameExtensionFilter(Strings.toStringEmptyProof(needFile.getDescription(), "file"), Strings.takeGroup(needFile.getSuggestedName(), matcher, 1).toString()));
+				}
+
+				frame.getContentPane().add(chooser);
+
+				chooser.addActionListener(new ActionListener() {
+
+					@Override
+					public void actionPerformed(ActionEvent event) {
+						if (event.getActionCommand().equals("CancelSelection")) {
+							needFile.getFuture().handle(new FramsticksException().msg("user cancelled choose"));
+							frame.setVisible(false);
+							frame.dispose();
+						}
+						if (event.getActionCommand().equals("ApproveSelection")) {
+							File file = null;
+							String filename = chooser.getSelectedFile().getAbsolutePath();
+							try {
+								file = new File("", new FileSource(filename));
+							} catch (IOException e) {
+								needFile.getFuture().handle(new FramsticksException().msg("failed to open choosed file").arg("filename", filename).cause(e));
+							}
+							if (file != null) {
+								done = true;
+								needFile.getFuture().pass(file);
+							}
+							frame.setVisible(false);
+							frame.dispose();
+						}
+					}
+				});
+				frame.setVisible(true);
+				return true;
+			}
+		};
+
+		tree.dispatch(new RunAt<Tree>(this) {
+			@Override
+			protected void runAt() {
+				log.debug("adding need file acceptor: {}", acceptor);
+				tree.addNeedFileAcceptor(Integer.MAX_VALUE, acceptor);
+			}
+		});
+
 	}
 
@@ -143,19 +229,19 @@
 		// final Tree i = trees.get("localhost");
 		// i.dispatch(new RunAt<Tree>(future) {
-		// 	@Override
-		// 	protected void runAt() {
-		// 		TreeOperations.tryGet(i, path, new FutureHandler<Path>(future) {
-		// 			@Override
-		// 			protected void result(final Path p) {
-		// 				future.pass(p);
-		// 				mainFrame.dispatch(new RunAt<Frame>(future) {
-		// 					@Override
-		// 					protected void runAt() {
-		// 						mainFrame.goTo(p);
-		// 					}
-		// 				});
-		// 			}
-		// 		});
-		// 	}
+		//	@Override
+		//	protected void runAt() {
+		//		TreeOperations.tryGet(i, path, new FutureHandler<Path>(future) {
+		//			@Override
+		//			protected void result(final Path p) {
+		//				future.pass(p);
+		//				mainFrame.dispatch(new RunAt<Frame>(future) {
+		//					@Override
+		//					protected void runAt() {
+		//						mainFrame.goTo(p);
+		//					}
+		//				});
+		//			}
+		//		});
+		//	}
 		// });
 	}
@@ -183,4 +269,5 @@
 						protected void runAt() {
 							final Path p = Path.to(i, "/");
+							log.debug("adding path: {}", p);
 							dispatch(new RunAt<Browser>(this) {
 								@Override
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 101)
@@ -243,5 +243,5 @@
 			@Override
 			public void actionPerformed(ActionEvent actionEvent) {
-				interrupt();
+				interruptJoinable();
 			}
 		});
@@ -268,4 +268,5 @@
 		log.debug("trying mount: {}", path);
 		if (!tree.getAssignedRoot().isResolved()) {
+			log.debug("root not yet assigned, geting root");
 			tree.get(path, new FutureHandler<Path>(this) {
 
Index: java/main/src/main/java/com/framsticks/gui/FrameJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 101)
@@ -31,5 +31,5 @@
 	 */
 	public FrameJoinable() {
-		statusBar = new StatusBar();
+		statusBar = new StatusBar(this);
 	}
 
@@ -101,5 +101,5 @@
 			@Override
 			protected void runAt() {
-				finish();
+				finishJoinable();
 			}
 		});
@@ -135,5 +135,5 @@
 			public void windowClosing(WindowEvent e) {
 				log.info("received closing");
-				interrupt();
+				interruptJoinable();
 			}
 		});
Index: java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 101)
@@ -7,6 +7,8 @@
 import javax.swing.Box;
 import javax.swing.BoxLayout;
+import javax.swing.JComponent;
 import javax.swing.JLabel;
 import javax.swing.JPanel;
+import javax.swing.border.TitledBorder;
 
 import org.apache.logging.log4j.Logger;
@@ -24,4 +26,5 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.Param;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.types.BinaryParam;
@@ -101,8 +104,8 @@
 	}
 
-	public static <P extends Param, C extends Control> void fillWithControls(ControlOwner owner, Collection<P> params, Map<P, C> components, Class<C> controlType) {
-		JPanel panel = owner.getPanelForControls();
+	public static <P extends Param, C extends Control> void fillWithControls(ControlOwner owner, JPanel panel, Collection<P> params, Map<String, C> components, Class<C> controlType) {
+		panel.setLayout(new BoxLayout(panel, BoxLayout.PAGE_AXIS));
 		for (P param : params) {
-			if (param.isUserHidden()) {
+			if (param.hasFlag(ParamFlags.USERHIDDEN)) {
 				continue;
 			}
@@ -122,21 +125,59 @@
 			line.setLayout(new BoxLayout(line, BoxLayout.LINE_AXIS));
 			line.setAlignmentX(JPanel.LEFT_ALIGNMENT);
-			JLabel label = new JLabel(Strings.notEmpty(param.getName()) ? param.getName() : (Strings.notEmpty(param.getId()) ? param.getId() : "?"));
-			label.setToolTipText(control.getToolTipText());
-			label.setHorizontalAlignment(JLabel.RIGHT);
-			Dimension labelSize = new Dimension(150, 30);
-			label.setMaximumSize(labelSize);
-			label.setMinimumSize(labelSize);
-			label.setPreferredSize(labelSize);
-			line.add(label);
-			line.add(Box.createRigidArea(new Dimension(8, 0)));
+
 			line.add(control);
 			line.revalidate();
 			panel.add(line);
 			panel.add(Box.createRigidArea(new Dimension(0, 8)));
+			components.put(param.getId(), control);
 			//component.setAlignmentX(LEFT_ALIGNMENT);
-			components.put(param, control);
+			// components.put(param.getId(), control);
 		}
 
 	}
+
+	public static String getBestName(Param param) {
+		if (Strings.notEmpty(param.getName())) {
+			return param.getName();
+		}
+		if (Strings.notEmpty(param.getId())) {
+			return param.getId();
+		}
+		return "?";
+	}
+
+	public static void setupTitledControl(Control control, JComponent... components) {
+
+		control.setLayout(new BoxLayout(control, BoxLayout.PAGE_AXIS));
+		control.setBorder(new TitledBorder(Gui.getBestName(control.getParam())));
+		for (JComponent c : components) {
+			// control.add(Box.createRigidArea(new Dimension(0, 4)));
+			control.add(c);
+		}
+	}
+
+	public static void layoutInRow(JPanel panel, JComponent first, JComponent... components) {
+		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
+		panel.setAlignmentX(JPanel.LEFT_ALIGNMENT);
+
+		panel.add(first);
+		for (JComponent c : components) {
+			panel.add(Box.createRigidArea(new Dimension(8, 0)));
+			panel.add(c);
+		}
+	}
+
+	public static void addLeftToLabel(Control control, JComponent... components) {
+
+		JLabel label = new JLabel(getBestName(control.getParam()));
+		label.setToolTipText(control.getToolTipText());
+		label.setHorizontalAlignment(JLabel.LEFT);
+		Dimension labelSize = new Dimension(150, 30);
+		label.setMaximumSize(labelSize);
+		label.setMinimumSize(labelSize);
+		label.setPreferredSize(labelSize);
+
+		layoutInRow(control, label, components);
+
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 101)
@@ -73,150 +73,4 @@
 	}
 
-	// private void onConnectionEstablished() {
-		// assert isActive();
-
-		// addNodeActionToTreePopupMenu("Open in console", new NodeAction() {
-			// @Override
-			// public void actionPerformed(TreeNode treeNode) {
-				// assert isActive();
-			// }
-		// });
-
-
-
-
-	// 	// browser.addNodeActionToTreePopupMenu("Resolve recursively", new NodeAction() {
-	// 	// 	@Override
-	// 	// 	public void actionPerformed(TreeNode treeNode) {
-	// 	// 		final Child child = treeNode.getChild();
-	// 	// 		//server.invokeLater(new Runnable() {
-	// 		// 		@Override
-	// 		// 		public void run() {
-	// 		// 			resolveRecursively(child);
-	// 		// 		}
-	// 		// 	});
-	// 	// }
-	// 	// });
-
-
-		// // addNodeActionToTreePopupMenu("Store in file", new NodeAction() {
-		// //     @Override
-		// //     public void actionPerformed(final TreeNode treeNode) {
-		// //         // final Node node = treeNode.getNode();
-		// //         // server.invokeLater(new Runnable() {
-		// //         //     @Override
-		// //         //     public void run() {
-		// //         //         try {
-		// //         //             log.info("storing");
-		// //         //             //File file = new File();
-		// //         //             StoreStream stream = new StoreStream(file, server.getManager());
-		// //         //             stream.store(node);
-		// //         //         } catch (FileNotFoundException e) {
-		// //         //             e.printStackTrace();
-		// //         //         }
-		// //         //     }
-		// //         // });
-		// //     }
-		// // });
-
-
-	// 	// arguments.forEach("resolve", new UnaryFunctor<Boolean, String>() {
-	// 	// 	@Override
-	// 	// 	public Boolean call(final String s) {
-	// 	// 		server.getManager().resolvePath(s, new StateFunctor() {
-	// 	// 			@Override
-	// 	// 			public void call(Exception e) {
-	// 	// 				if (e != null) {
-	// 	// 					log.error("failed to resolve: {}", s);
-	// 	// 					return;
-	// 	// 				}
-	// 	// 				log.info("succeeded to resolve: {}", s);
-	// 	// 			}
-	// 	// 		});
-	// 	// 		return true;
-	// 	// 	}
-	// 	// });
-
-
-	// 	// arguments.forEach("console", new UnaryFunctor<Boolean, String>() {
-	// 	// 	@Override
-	// 	// 	public Boolean call(String s) {
-	// 	// 		showConsoleFrame().setCommandLine(s);
-	// 	// 		return true;
-	// 	// 	}
-	// 	// });
-	// }
-
-
-	// /**
-	//  * Creates panel with start, step, stop buttons.
-	//  */
-	// @Override
-	// protected JPanel createLeftTopPanel() {
-	// 	assert isActive();
-	// 	Dimension buttonDimension = new Dimension(45, 45);
-
-	// 	JPanel panel = new JPanel();
-
-	// 	stop = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STOP));
-	// 	stop.addActionListener(new ActionListener() {
-
-	// 		public void actionPerformed(ActionEvent e) {
-	// 			setSimulationRunning(false);
-	// 		}
-
-	// 	});
-
-	// 	stop.setPreferredSize(buttonDimension);
-	// 	stop.setToolTipText("Simulation Stop");
-	// 	stop.setEnabled(false);
-
-	// 	step = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STEP));
-	// 	/*
-	// 	step.addActionListener(new ActionListener() {
-
-	// 		public void actionPerformed(ActionEvent e) {
-	// 			connection.send(new CallQuery().setMethod("step").setPath("/simulator"));
-	// 		}
-
-	// 	});
-	// 	*/
-
-	// 	step.setPreferredSize(buttonDimension);
-	// 	step.setToolTipText("Simulation Step");
-
-	// 	start = new JButton(ImageProvider.loadImage(ImageProvider.SIM_START));
-	// 	start.addActionListener(new ActionListener() {
-
-	// 		public void actionPerformed(ActionEvent e) {
-	// 			setSimulationRunning(true);
-	// 		}
-
-	// 	});
-
-	// 	start.setPreferredSize(buttonDimension);
-	// 	start.setToolTipText("Start Simulation");
-
-	// 	JPanel buttonPanel = new JPanel();
-	// 	buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
-	// 	buttonPanel.add(Box.createHorizontalStrut(5));
-	// 	buttonPanel.add(stop);
-	// 	buttonPanel.add(Box.createHorizontalStrut(10));
-	// 	buttonPanel.add(step);
-	// 	buttonPanel.add(Box.createHorizontalStrut(10));
-	// 	buttonPanel.add(start);
-	// 	buttonPanel.add(Box.createHorizontalStrut(5));
-
-	// 	buttonPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory
-	// 			.createRaisedBevelBorder(), "Simulation Control",
-	// 			TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION
-	// 			));
-
-	// 	panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
-	// 	panel.add(Box.createHorizontalGlue());
-	// 	panel.add(buttonPanel);
-	// 	panel.add(Box.createHorizontalGlue());
-	// 	return panel;
-	// }
 
 	/**
@@ -248,14 +102,4 @@
 	}
 
-	// public ConsoleFrame showConsoleFrame() {
-	// 	assert isActive();
-	// 	/*
-	// 	ConsoleFrame consoleFrame = new ConsoleFrame(connection);
-	// 	consoleFrame.show(MainFrame.this);
-	// 	return consoleFrame;
-	// 	*/
-	// 	return null;
-	// }
-
 	/**
 	 * Closes connection with manager.
Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 101)
@@ -9,4 +9,5 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
+import static com.framsticks.core.TreeOperations.*;
 
 /**
@@ -24,4 +25,5 @@
 	protected final JLabel label;
 	protected final JButton applyButton;
+	protected final JButton revertButton;
 	protected final JPanel centerPanel;
 
@@ -32,6 +34,4 @@
 		log.debug("create panel for type: {}", className);
 
-
-
 		JPanel pageEndPanel = new JPanel();
 		pageEndPanel.setLayout(new BoxLayout(pageEndPanel, BoxLayout.X_AXIS));
@@ -41,4 +41,15 @@
 		applyButton.setName("apply");
 
+		revertButton = new JButton("Revert");
+		revertButton.setName("revert");
+
+		pageEndPanel.add(applyButton);
+		pageEndPanel.add(Box.createHorizontalStrut(10));
+
+		pageEndPanel.add(revertButton);
+		pageEndPanel.add(Box.createHorizontalStrut(10));
+
+		pageEndPanel.setPreferredSize(new Dimension(0, 30));
+
 		applyButton.addActionListener(new ActionListener() {
 			public void actionPerformed(ActionEvent e) {
@@ -46,8 +57,10 @@
 			}
 		});
-		pageEndPanel.add(applyButton);
 
-		pageEndPanel.add(Box.createHorizontalStrut(10));
-		pageEndPanel.setPreferredSize(new Dimension(0, 30));
+		revertButton.addActionListener(new ActionListener() {
+			public void actionPerformed(ActionEvent e) {
+				revertChanges();
+			}
+		});
 
 		label = new JLabel();
@@ -67,4 +80,5 @@
 
 	protected abstract void applyChanges();
+	protected abstract void revertChanges();
 
 	protected void setupContentComponent(Component contentComponent) {
@@ -73,3 +87,10 @@
 	}
 
+	protected void refreshControlButtons() {
+		assert frame.isActive();
+		boolean hasChanges = hasSideNotes(getTree(), getCurrentObject(), treeAtFrame.getUserChangesKey());
+		applyButton.setEnabled(hasChanges);
+		revertButton.setEnabled(hasChanges);
+	}
+
 }
